import { Application, ChannelService, FrontendSession, RemoterClass, HandlerService, } from 'pinus';
import { PVPConfigType } from '../../../db/SystemConfig';
import { reloadResources } from '../../../pubUtils/data';
import { getServerMainten, setServerMainten, stopServerMainten } from '../../../services/gmService';
import { taflush } from '../../../services/sdkService';

export default function (app: Application) {
    new HandlerService(app, {});
    return new BattleRemote(app);
}

export class BattleRemote {

    constructor(private app: Application) {
        this.app = app;
        this.channelService = app.get('channelService');
    }

    private channelService: ChannelService;

    /**
     * Add user into chat channel.
     *
     * @param {String} uid unique id for user
     * @param {String} sid server id
     * @param {boolean} flag channel parameter
     *
     */
    public async add(uid: string, sid: string, serverId: number, flag: boolean) {
        let name = `server-${serverId}`;
        console.log('BattleRemote add: ', name, flag);
        let channel = this.channelService.getChannel(name, flag);
        if (!!channel && !this.get(name, false).includes(uid)) {
            if (!!channel) {
                channel.add(uid, sid);
            }
        }
        return this.get(name, flag);
    }

    /**
     * Get user from chat channel.
     *
     * @param {Object} opts parameters for request
     * @param {String} name channel name
     * @param {boolean} flag channel parameter
     * @return {Array} users uids in channel
     *
     */
    private get(name: string, flag: boolean) {
        let users: string[] = [];
        let channel = this.channelService.getChannel(name, flag);
        if (!!channel) {
            users = channel.getMembers();
        }
        for (let i = 0; i < users.length; i++) {
            users[i] = users[i].split('*')[0];
        }
        return users;
    }

    /**
     * Kick user out chat channel.
     *
     * @param {String} uid unique id for user
     * @param {String} sid server id
     *
     */
    public async kick(uid: string, sid: string, serverId: number) {
        let name = `server-${serverId}`;
        let channel = this.channelService.getChannel(name, false);
        // leave channel
        if (!!channel) {
            channel.leave(uid, sid);
        }
    }

    /**
     * 重载json资源
     */
    public async reloadResources() {
        reloadResources();
    }


    public setPvpSeasonNum(pvpConfig: PVPConfigType) {
        if(pvpConfig) {
            this.app.set('pvpSeasonNum', pvpConfig.seasonNum);
            this.app.set('pvpSeasonEndTime', pvpConfig.seasonEndTime);
        }
    }

    public setServerMainten(serverIds: number[], startTime: number, endTime: number) {
        setServerMainten(serverIds, startTime, endTime);
    }

    public stopServerMainten(serverIds: number[]) {
        stopServerMainten(serverIds);
    }

    public getServerMainten(serverId: number) {
        return getServerMainten(serverId);
    }

    public taflush() {
        return taflush();
    }
}